function AFMMgpu3plots(all,errorplot)
% AFMMGPU3PLOTS Plots for the paper "Adaptive fast multipole method on
% the GPU".
if nargin<1
  all=false;
end
if nargin<2
  errorplot=false;
end
%Timing of individual parts
plotparams={'LineWidth',0.75};
load examples/data/AFMMgpu3
line1='-k';
line2='--k';
line3='-.r';
line4=':r';
line5='-b';
line6='--b';
line7='.-b';
line8='--m';

%calculate averages for each number of points
% cuda_nosort_timing_deval2=mean(cuda_nosort_timing_deval,3);
% cuda_timing_deval2=mean(cuda_timing_deval,3);
% cpu_nompeval_timing_deval2=mean(cpu_nompeval_timing_deval,3);
% cpu_nodirect_timing_deval2=mean(cpu_nodirect_timing_deval,3);
% cuda_nosort_timing_deval3=mean(cuda_nosort_timing_deval2,2);
% cuda_timing_deval3=mean(cuda_timing_deval2,2);
% cpu_nompeval_timing_deval3=mean(cpu_nompeval_timing_deval2,2);
% cpu_nodirect_timing_deval3=mean(cpu_nodirect_timing_deval2,2);
[cuda_nosort_timing_deval3 cuda_nosort_timing_deval3stdev]=AFMMgpu_post_process(cuda_nosort_timing_deval,1,1);
[cuda_timing_deval3 cuda_timing_deval3stdev]=AFMMgpu_post_process(cuda_timing_deval,1,1);
[cpu_nompeval_timing_deval3 cpu_nompeval_timing_deval3stdev]=AFMMgpu_post_process(cpu_nompeval_timing_deval,1,1);
[cpu_nodirect_timing_deval3 cpu_nodirect_timing_deval3stdev]=AFMMgpu_post_process(cpu_nodirect_timing_deval,1,1);

if all
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,2),line1,nn/2^16,cuda_timing_deval3(:,2),line2);
  legend('CPU time','GPU time');
  title('Sorting time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  semilogx(nn/2^16,cpu_nompeval_timing_deval3(:,2)./cuda_timing_deval3(:,2),line1);
  title('Sorting time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,3),line1,nn/2^16,cuda_nosort_timing_deval3(:,3),line2);
  legend('CPU time','GPU time');
  title('Connectivity time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  semilogx(nn/2^16,cpu_nompeval_timing_deval3(:,3)./cuda_nosort_timing_deval3(:,3),line1);
  title('Connectivity time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,5),line1,nn/2^16,cuda_nosort_timing_deval3(:,23),line2);
  legend('CPU time','GPU time');
  title('Initialization time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  plot(nn/2^16,cpu_nompeval_timing_deval3(:,5)./cuda_nosort_timing_deval3(:,23),line1);
  title('Initialization time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,6),line1,nn/2^16,cuda_nosort_timing_deval3(:,24),line2);
  legend('CPU time','GPU time');
  title('m2m time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  semilogx(nn/2^16,cpu_nompeval_timing_deval3(:,6)./cuda_nosort_timing_deval3(:,24),line1);
  title('m2m time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,7),line1,nn/2^16,cuda_nosort_timing_deval3(:,25),line2);
  legend('CPU time','GPU time');
  title('m2ps time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  semilogx(nn/2^16,cpu_nompeval_timing_deval3(:,7)./cuda_nosort_timing_deval3(:,25),line1);
  title('m2ps time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,8),line1,nn/2^16,cuda_nosort_timing_deval3(:,26),line2);
  legend('CPU time','GPU time');
  title('p2p time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  semilogx(nn/2^16,cpu_nompeval_timing_deval3(:,8)./cuda_nosort_timing_deval3(:,26),line1);
  title('p2p time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nodirect_timing_deval3(:,9),line1,nn/2^16,cuda_nosort_timing_deval3(:,27),line2);
  legend('CPU time','GPU time');
  title('multipole evaluation time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  plot(nn/2^16,cpu_nodirect_timing_deval3(:,9)./cuda_nosort_timing_deval3(:,27),line1);
  title('multipole evaluation time');
  xlabel('Number of points in box');
  ylabel('Speedup');
  
  figure
  loglog(nn/2^16,cpu_nompeval_timing_deval3(:,9),line1,nn/2^16,cuda_nosort_timing_deval3(:,28),line2);
  legend('CPU time','GPU time');
  title('direct evaluation time');
  xlabel('Number of points in box');
  ylabel('Time (s)');
  figure
  plot(nn/2^16,cpu_nompeval_timing_deval3(:,9)./cuda_nosort_timing_deval3(:,28),line1);
  title('direct evaluation time');
  xlabel('Number of points in box');
  ylabel('Speedup');
end

figure
plot(nn/2^16,cuda_timing_deval3(:,2),line1);
hold on;
plot(nn/2^16,cuda_nosort_timing_deval3(:,3),line2);
plot(nn/2^16,cuda_nosort_timing_deval3(:,23),line3);
plot(nn/2^16,cuda_nosort_timing_deval3(:,24),line4);
plot(nn/2^16,cuda_nosort_timing_deval3(:,25),line5);
plot(nn/2^16,cuda_nosort_timing_deval3(:,26),line6);
plot(nn/2^16,cuda_nosort_timing_deval3(:,27),line7);
plot(nn/2^16,cuda_nosort_timing_deval3(:,28),line8);
legend('Sort','Connectivity','Initialization','m2m','m2ps','p2p','Multipole eval','Direct eval');
% legend('Initialization','Multipole eval','Direct eval');
xlabel('Number of points in box');
ylabel('GPU Time');

figure
plot(nn/2^16,cpu_nompeval_timing_deval3(:,2),line1);
hold on;
plot(nn/2^16,cpu_nompeval_timing_deval3(:,3),line2);
plot(nn/2^16,cpu_nompeval_timing_deval3(:,5),line3);
plot(nn/2^16,cpu_nompeval_timing_deval3(:,6),line4);
plot(nn/2^16,cpu_nompeval_timing_deval3(:,7),line5);
plot(nn/2^16,cpu_nompeval_timing_deval3(:,8),line6);
plot(nn/2^16,cpu_nodirect_timing_deval3(:,9),line7);
plot(nn/2^16,cpu_nompeval_timing_deval3(:,9),line8);
legend('Sort','Connectivity','Initialization','m2m','m2ps','p2p','Multipole eval','Direct eval');
% legend('Initialization','Multipole eval','Direct eval');
xlabel('Number of points in box');
ylabel('CPU Time');

figure
plot(nn/2^16,cpu_nompeval_timing_deval3(:,2)./cuda_timing_deval3(:,2),line1,plotparams{:});
hold on;
%plot(nn/2^16,cpu_nompeval_timing_deval3(:,3)./cuda_nosort_timing_deval3(:,3),line2,plotparams{:});
plot(nn/2^16,cpu_nompeval_timing_deval3(:,5)./cuda_nosort_timing_deval3(:,23),line3,plotparams{:});
%plot(nn/2^16,cpu_nompeval_timing_deval3(:,6)./cuda_nosort_timing_deval3(:,24),line4,plotparams{:});
%plot(nn/2^16,cpu_nompeval_timing_deval3(:,7)./cuda_nosort_timing_deval3(:,25),line5,plotparams{:});
%plot(nn/2^16,cpu_nompeval_timing_deval3(:,8)./cuda_nosort_timing_deval3(:,26),line6,plotparams{:});
plot(nn/2^16,cpu_nodirect_timing_deval3(:,9)./cuda_nosort_timing_deval3(:,27),line7,plotparams{:});
plot(nn/2^16,cpu_nompeval_timing_deval3(:,9)./ ...
     cuda_nosort_timing_deval3(:,28),line8,plotparams{:});

h = legend('Sort','P2M', ...
           'L2P','P2P', ...
           'location','NW'); set(h,'FontSize',10);
if errorplot
  hold on;
  nw = 20; % number of errorbars
  w = floor(numel(nn)/nw);
  eline1 = [line1(end) '.']; % plot only bars and no graphs
  eline3 = [line3(end) '.'];
  eline7 = [line7(end) '.'];
  eline8 = [line8(end) '.'];
  [timing,stdev] = getdivstdev(cpu_nompeval_timing_deval3(:,2), ...
                               cuda_timing_deval3(:,2), ...
                               cpu_nompeval_timing_deval3stdev(:,2), ...
                               cuda_timing_deval3stdev(:,2));
  h1 = errorbar(nn(1:w:end)/2^16,timing(1:w:end),0.5*stdev(1:w:end),eline1);
  [timing,stdev] = getdivstdev(cpu_nompeval_timing_deval3(:,5), ...
                               cuda_nosort_timing_deval3(:,23), ...
                               cpu_nompeval_timing_deval3stdev(:,5), ...
                               cuda_nosort_timing_deval3stdev(:,23));
  h2 = errorbar(nn(1:w:end)/2^16,timing(1:w:end),0.5*stdev(1:w:end),eline3);
  [timing,stdev] = getdivstdev(cpu_nodirect_timing_deval3(:,9), ...
                               cuda_nosort_timing_deval3(:,27), ...
                               cpu_nodirect_timing_deval3stdev(:,9), ...
                               cuda_nosort_timing_deval3stdev(:,27));
  h3 = errorbar(nn(1:w:end)/2^16,timing(1:w:end),0.5*stdev(1:w:end),eline7);
  [timing,stdev] = getdivstdev(cpu_nompeval_timing_deval3(:,9), ...
                               cuda_nosort_timing_deval3(:,28), ...
                               cpu_nompeval_timing_deval3stdev(:,9), ...
                               cuda_nosort_timing_deval3stdev(:,28));
  h4 = errorbar(nn(1:w:end)/2^16,timing(1:w:end),0.5*stdev(1:w:end),eline8);
  
  errorbar_tick(h1,3,'units');
  errorbar_tick(h2,3,'units');
  errorbar_tick(h3,3,'units');
  errorbar_tick(h4,3,'units');
end

h = xlabel('N_{d}'); set(h,'FontSize',10);
h = ylabel('Speedup'); set(h,'FontSize',10);
set(gca,'xtick',0:10:70,'ytick',[0:5:25]);
axis([0 75 0 25]);
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 220]);
print -depsc examples/fig/ndirspeedup.eps
