% AFMMGPU4PLOTS Plots for the paper "Adaptive fast multipole method on
% the GPU".

%Find ndirect as function of tol
%Code not tested yet
load examples/data/AFMMgpu4
plotparams={'LineWidth',0.75};
line1='-k';
line2='--k';
line3='-b';
line4='--b';
%calculate averages for each number of points
% cuda_ndirect=cuda_ndirect_tol(:,:,:,:,:,10);
% cpu_ndirect=cpu_ndirect_tol(:,:,:,:,:,10);
% cuda_ndirect2=mean(cuda_ndirect,5);
% cpu_ndirect2=mean(cpu_ndirect,5);
% cuda_ndirect3=mean(cuda_ndirect2,4);
% cpu_ndirect3=mean(cpu_ndirect2,4);

cuda_ndirect3=AFMMgpu_post_process(cuda_ndirect_tol(:,:,:,:,:,10),3,0);
cpu_ndirect3=AFMMgpu_post_process(cpu_ndirect_tol(:,:,:,:,:,10),3,0);
cuda_ndirect_total=sum(cuda_ndirect3,3);
cpu_ndirect_total=sum(cpu_ndirect3,3);
cuda_ndirect_scaled=sum(cuda_ndirect3./(repmat(min(cuda_ndirect3,[],2),[1,size(cuda_ndirect3,2),1])),3);
cpu_ndirect_scaled=sum(cpu_ndirect3./(repmat(min(cpu_ndirect3,[],2),[1 size(cpu_ndirect3,2),1])),3);
cuda_ndirect_weigted=sum(cuda_ndirect3./(repmat(min(cuda_ndirect3,[],2),[1,size(cuda_ndirect3,2),1]).*repmat(reshape(log2(nn),1,1,length(nn)),[size(cuda_ndirect3,1),size(cuda_ndirect3,2),1])),3);
cpu_ndirect_weigted=sum(cpu_ndirect3./(repmat(min(cpu_ndirect3,[], ...
                                                  2),[1,size(cpu_ndirect3,2),1]).*repmat(reshape(log2(nn),1,1,length(nn)),[size(cpu_ndirect3,1),size(cpu_ndirect3,2),1])),3);

% production quality figure:
figure
[dummy,indcpu] = min(cpu_ndirect_scaled,[],2);
[dummy,indcuda] = min(cuda_ndirect_scaled,[],2);
plot(pp,ndir(indcuda),line1,pp,ndir(indcpu),line4,plotparams{:});
h = xlabel('p'); set(h,'FontSize',10);
h = ylabel('N_{d}'); set(h,'FontSize',10);
h = legend('GPU','CPU','Location','SE'); set(h,'FontSize',10);
axis([pp([1 end]) 0 80])
set(gca,'xtick',0:10:50,'ytick',[0:20:80]);
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 200]);
print -depsc examples/fig/Ndirecttol.eps