% AFMMGPU7 Computational experiment for the paper "Adaptive fast
% multipole method on the GPU".

% Pie chart
% This function determines the timing of individual parts for 8 levels, one
% is the firt N that gives 8 levels, one is middle element and one is last
% N that gives 8 levels. Used for pie chart

if exist('./examples/data/AFMMgpu7.mat','file')
  warning('Existing file AFMMgpu7.mat NOT overwritten.');
end

clear all
rand('state',20120225);

%Timing of individual parts
Ndirect=45;
nn=[Ndirect*2^17/5+1 Ndirect*2^16 Ndirect*2^19/5];%minimum
tol=1e-6;
Nsets=10;
Naverages=10;

for k=1:length(nn)
  tic
  for m=1:Nsets
    vortices=rand(1,nn(k))+1i*rand(1,nn(k));
    gammas=rand(1,nn(k));
    fmm2dCUDA( vortices,gammas,'pot',1,'ndirect',Ndirect,'tol',tol,'out','time'); %one call before timing to access all elements in array first
    for n=1:Naverages
      cuda_timing_pie(k,m,n,:)=fmm2dCUDA( vortices,gammas,'pot',1,'ndirect',Ndirect,'tol',tol,'out','time');
    end
  end
   disp(['step ' num2str(k) ' points ' num2str(nn(k)) ' time ' num2str(toc)]);
end

if ~exist('./examples/data/AFMMgpu7.mat','file')
  save examples/data/AFMMgpu7 cuda_timing_pie nn Ndirect tol
end
