function AFMMgpu7plots
% AFMMGPU7PLOTS Plots for the paper "Adaptive fast multipole method on
% the GPU".

%Timing of individual parts
load examples/data/AFMMgpu7
%calculate averages for each number of points
% cuda_timing_pie2=mean(cuda_timing_pie,3);
% cuda_timing_pie3=mean(cuda_timing_pie2,2);
cuda_timing_pie3=AFMMgpu_post_process(cuda_timing_pie,1,1);

othertime=cuda_timing_pie3(:,10)-cuda_timing_pie3(:,2)-cuda_timing_pie3(:,3)-cuda_timing_pie3(:,23)-...
         cuda_timing_pie3(:,24)-cuda_timing_pie3(:,25)-cuda_timing_pie3(:,26)-...
         cuda_timing_pie3(:,27)-cuda_timing_pie3(:,28);
timings=[cuda_timing_pie3(:,2) cuda_timing_pie3(:,3) cuda_timing_pie3(:,23) ...
         cuda_timing_pie3(:,24) cuda_timing_pie3(:,25) cuda_timing_pie3(:,26) ...
         cuda_timing_pie3(:,28) cuda_timing_pie3(:,27) othertime];
Names = {'Sort: ';'Connect: ';'P2M: ';'M2M: ';'M2L: ';'L2L: ';'P2P: ';'L2P: ';'Other: '};

figure
mypie(timings(1,:),Names);

figure
mypie(timings(2,:),Names);
print -depsc examples/fig/pie.eps

figure
mypie(timings(3,:),Names);

function mypie(timings,Names)

h=pie(timings./sum(timings));
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 250]);

%copied from matlab help file
textObjs = findobj(h,'Type','text');
oldStr = get(textObjs,{'String'});
val = get(textObjs,{'Extent'});
oldExt = cat(1,val{:});

%Create the new strings, and set the text objects' String properties to the new strings:

newStr = strcat(Names,oldStr);
set(textObjs,{'String'},newStr)

%Find the difference between the widths of the new and old text strings and change the values of the Position properties:

val1 = get(textObjs, {'Extent'});
newExt = cat(1, val1{:});
offset = sign(oldExt(:,1)).*(newExt(:,3)-oldExt(:,3))/2;
pos = get(textObjs, {'Position'});
textPos =  cat(1, pos{:});
textPos(:,1) = textPos(:,1)+offset;
set(textObjs,{'Position'},num2cell(textPos,[3,2]))
set(textObjs,'FontSize',10)

