% evaltimefarfield_plots Plots for the paper "A General high order two-
% dimensional panel method".

load examples/generalpanel/data/generalpanelfarfield
plotparams={'LineWidth',0.75};
line1='-b';
line2='-.b';
line3='--b';
line4=':b';
line5='-k';
line6='-.k';
line7='--k';
line8=':k';
line9='-g';
line10='-.g';
line11='--g';
line12=':g';

%calculate averages for each number of points
ltime=AFMMgpu_post_process(lintimesrc(:,:,10),1,0);
ctime=AFMMgpu_post_process(cubtimesrc(:,:,10),1,0);
qtime=AFMMgpu_post_process(quinttimesrc(:,:,10),1,0);
stime=AFMMgpu_post_process(septtimesrc(:,:,10),1,0);
lctime=AFMMgpu_post_process(lincubtimesrc(:,:,10),1,0);
cctime=AFMMgpu_post_process(cubcubtimesrc(:,:,10),1,0);
qctime=AFMMgpu_post_process(quintcubtimesrc(:,:,10),1,0);
sctime=AFMMgpu_post_process(septcubtimesrc(:,:,10),1,0);
lqtime=AFMMgpu_post_process(linquinttimesrc(:,:,10),1,0);
cqtime=AFMMgpu_post_process(cubquinttimesrc(:,:,10),1,0);
qqtime=AFMMgpu_post_process(quintquinttimesrc(:,:,10),1,0);
sqtime=AFMMgpu_post_process(septquinttimesrc(:,:,10),1,0);
rtime=AFMMgpu_post_process(reftimesrc(:,:,10),1,0);
rval=mean(rtime);


figure
plot(paneleval,lctime-rval,line5,plotparams{:});
hold on;
plot(paneleval,cctime-rval,line6,plotparams{:});
plot(paneleval,qctime-rval,line7,plotparams{:});
plot(paneleval,sctime-rval,line8,plotparams{:});
h = xlabel('Number of panels','FontSize',10);
h = ylabel('Time (s)','FontSize',10);
h = legend('M=1','M=2','M=4','M=6');
set(gcf,'PaperPositionMode','auto');
set(gcf,'Position',[100 100 380 200]);