% karmantrefftzangle
%
% Calculate the karman trefftz mapping to the z plane, using position angle
% value theta, circle center my, mapping coefficient n and circle radius R
function z=karmantrefftzangle(theta,my,n,R)
if nargin<4
  R=1;
end
s=R*sqrt((1-real(my))^2+imag(my)^2).*exp(1i*theta)+my;
t1=(1+1./s).^n;
t2=(1-1./s).^n;
z=n*(t1+t2)./(t1-t2);