% karmantrefftzangled
%
% Calculate the derivate of the karman trefftz mapping using position angle
% value theta, circle center my, mapping coefficient n
function z=karmantrefftzangled(theta,my,n)
s=sqrt((1-real(my))^2+imag(my)^2).*exp(1i*theta)+my;
t1=(1+1./s).^n;
t2=(1-1./s).^n;
z=4.*n.*n.*(t1.*t2)./((s.^2-1).*(t1-t2).^2);