% karmantrefftzvelocity
%
% Evaluate the flow velocity around a karman trefftz wing, described by s
% coordinates, circle center my, mapping coefficient n, scalar flow
% velocity Vasympt and flow direction alpha
function V=karmantrefftzvelocity(s,my,n,Vasympt,alpha)
R=sqrt((1-real(my))^2+imag(my)^2);
Gamma=4*pi*Vasympt*R*sin(alpha+asin(imag(my)/R));
V=conj((Vasympt*exp(-1i*alpha)+1i*Gamma./(2*pi*(s-my))-Vasympt*R^2*exp(1i*alpha)./(s-my).^2)./karmantrefftzd(s,n));