% plotcirclepanelmesh
%
% This is a plot script to show the FMM mesh and the panels for the far
% field evaluation case
function plotcirclepanelmesh(Npanel,Neval)
% Plot data
vortexlinestyle={'kx'};
panellinestyle={'k'};
panelendpointlinestyle={'ko'};
meshlinestyle={'k'};

% Set up panels
anglesd=linspace(0,2*pi,Npanel+1);
panelpointsd=exp(1i*anglesd(1:end-1));
paneldirectionsd=1i*exp(1i*anglesd(1:end-1));
cubpanels=highorderpanelstrength(panelpointsd,paneldirectionsd,[],[],1,1,0,0,0,1);
eval=(9*rand(1,Neval)+1).*exp(2i*pi*rand(1,Neval));

% Get mesh
M=fmm2d([],[],eval,'pot',1,'tol',1e-9,'out','mesh','ndirect',35,'destinationmesh',true,'sourcepanels',{'cubshape',cubpanels.panels,cubpanels.directions,'linstrength',cubpanels.strength});

% Plot
figure
plot(eval,vortexlinestyle{:})
hold on;
plot(cubpanels.panels,panelendpointlinestyle{:})
plotgeneralpanel(cubpanels.panels,fmm2d([],[],eval,'pot',1,'tol',1e-9,'out','panels','ndirect',35,'destinationmesh',true,'sourcepanels',{'cubshape',cubpanels.panels,cubpanels.directions,'linstrength',cubpanels.strength}),panellinestyle{:})
meshplot(M{end},meshlinestyle{:})
axis equal;