% plot the normal component of the flow velocity over a panel, which is
% used to study the error of the panel approximation. Vasympt is the flow
% velocity, panels is the panels to plot, and varargin can be used to
% define the panels
function [err1, err2]=plotgeneralpanelnormalvelocity(vasympt,panels,varargin)
% Get panel coefficients
a=fmm2d([],[],'pot',1,'tol',0,'out','panels','sourcepanels',varargin);
% Generate set of points along the panel
step=0.001;
[points, n]=generalpanelcontrolpoint(step/2:step:1-step/2,panels,a);
xx=[0;cumsum(abs(points(2:end)-points(1:end-1)))];
% Evaluate flow velocity on the panel points
yy=real(-conj(vasympt)*n-fmm2d([],[],points,'pot',1,'tol',0,'sourcepanels',varargin)/2/pi.*n);
% Plot the results
plot(xx,yy);
hold on;
panelends=[0 cumsum(abs(panels(2,:)-panels(1,:)))];
plot(panelends,zeros(size(panelends)),'bx');
err1=sum(yy);
err2=rms(yy);