% unitcircleconvergence_plots Plots for the paper "A General high order two-
% dimensional panel method".
%
% Plots for the unit circle tests.
% This requires that unitcircleconvergence_run has been called before.
% Configurations are done in that script

function unitcircleconvergence_plot(filename)

load(filename);

pos=[94   391   650   504];
legendpos=[0.70974358974359 0.478174603174603 0.255384615384615 0.498677248677248];

% The plot where accuracy is compared to distance from the circle
if diststudy
  for k=1:length(panelcount)
    figure
    loglog(sp,linerror{k},'b','LineWidth',1);
    hold on;
    loglog(sp,cuberror{k},'-.b','LineWidth',1);
    loglog(sp,quinterror{k},'--b','LineWidth',1);
    loglog(sp,septerror{k},':b','LineWidth',1);
    loglog(sp,lincuberror{k},'r','LineWidth',1);
    loglog(sp,cubcuberror{k},'-.r','LineWidth',1);
    loglog(sp,quintcuberror{k},'--r','LineWidth',1);
    loglog(sp,septcuberror{k},':r','LineWidth',1);
    loglog(sp,linquinterror{k},'g','LineWidth',1);
    loglog(sp,cubquinterror{k},'-.g','LineWidth',1);
    loglog(sp,quintquinterror{k},'--g','LineWidth',1);
    loglog(sp,septquinterror{k},':g','LineWidth',1);
    loglog(sp,linsepterror{k},'m');
    loglog(sp,cubsepterror{k},'-.m');
    loglog(sp,quintsepterror{k},'--m');
    loglog(sp,septsepterror{k},':m');
    title(['Distance: ' num2str(distval(k)) ' vortexpanels: ' num2str(vortexpanels) ' controlpoints: ' num2str(controlpoint) ' slopecorr: ' num2str(slopecorrection)]);
    legend('M=1, N=1','M=3, N=1','M=5, N=1','M=7, N=1', ...
      'M=1, N=3','M=3, N=3','M=5, N=3','M=7, N=3',...
      'M=1, N=5','M=3, N=5','M=5, N=5','M=7, N=5',...
      'M=1, N=7','M=3, N=7','M=5, N=7','M=7, N=7');
    legend1 = legend(gca,'show');
    set(legend1,'Position',legendpos);
    set(gcf,'Position',pos);
    set(gca,'FontSize',14);
    xlabel('Distance','FontSize',14);
    ylabel('Error','FontSize',14);
  end
end

% The plot where accuracy is compared to number of panels
if panelstudy
  for k=1:length(distval)
    figure
    semilogy(paneleval,linerrord{k},'b');
    hold on;
    semilogy(paneleval,cuberrord{k},'-.b');
    semilogy(paneleval,quinterrord{k},'--b');
    semilogy(paneleval,septerrord{k},':b');
    semilogy(paneleval,lincuberrord{k},'r');
    semilogy(paneleval,cubcuberrord{k},'-.r');
    semilogy(paneleval,quintcuberrord{k},'--r');
    semilogy(paneleval,septcuberrord{k},':r');
    semilogy(paneleval,linquinterrord{k},'g');
    semilogy(paneleval,cubquinterrord{k},'-.g');
    semilogy(paneleval,quintquinterrord{k},'--g');
    semilogy(paneleval,septquinterrord{k},':g');
    semilogy(paneleval,linsepterrord{k},'m');
    semilogy(paneleval,cubsepterrord{k},'-.m');
    semilogy(paneleval,quintsepterrord{k},'--m');
    semilogy(paneleval,septsepterrord{k},':m');
    title(['Distance: ' num2str(distval(k)) ' vortexpanels: ' num2str(vortexpanels) ' controlpoints: ' num2str(controlpoint) ' slopecorr: ' num2str(slopecorrection)]);
    legend('M=1, N=1','M=3, N=1','M=5, N=1','M=7, N=1', ...
      'M=1, N=3','M=3, N=3','M=5, N=3','M=7, N=3',...
      'M=1, N=5','M=3, N=5','M=5, N=5','M=7, N=5',...
      'M=1, N=7','M=3, N=7','M=5, N=7','M=7, N=7');
    legend1 = legend(gca,'show');
    set(legend1,'Position',legendpos);
    set(gcf,'Position',pos);
    set(gca,'FontSize',14);
    xlabel('Number of panels','FontSize',14)
    ylabel('Error','FontSize',14)
  end
  
end