% unitcirclevalidation
%
% Calculates the error from the panel approximation around a circle at
% chosen distance. Note that distance is the circle radius, i.e. distance =
% 1 is at the circle boundary. The panels are defined in varargin

function error=unitcirclevalidation(distance,varargin)
% Integrate the test function (quadratic error) around the circle,
% normalize with length of integral
error=sqrt(quadgk(@(zp)(testvalue(zp,distance,varargin{:}).^2),0,2*pi))/sqrt(2*pi);

function ret=testvalue(angleval,distance,varargin)
r=distance*exp(1i*angleval);   % Determine the points
exact=conj(1-1./r.^2);         % Reference solution
approx=conj(fmm2d([],[],r,'pot',1,'tol',0,'sourcepanels',varargin)/2/pi)+1; %Panel solution
ret=abs(exact-approx);         % return the difference