% GENERALPANEL_COMPILE Compiles several versions of the FMM.

% A. Goude 2017-04-20

% Compile splitgeneralpanel.cpp first (used for tests)
cd source/generalpanel
make_splitgeneralpanel
cd ../../

debug_defs = {'-DEBUGPANELSORT' ...       % (1)
              '-DNOMULTIPOLEEVAL'...      % (2) %removes multipoleevaluation, for speed measurements
              '-DNODIRECTEVAL'...         % (3) %removes direct evaluation, for speed measurements
             };
platform_defs = {'-DmwIndex=int' ...      % (1)
                 '-DmwSize=int' ...       % (2)
                };
fmm_defs = {'-DINLINECOMPLEX' ...         % (1)
            '-DINLINECOMPLEX_DIRECT' ...  % (2)
            '-DTHETACUTOFFCHECK' ...      % (3)
            '-DFMM_THETA=0.5' ...         % (4)
            '-DFMM_MESHRATIO=2.0' ...     % (5)
            '-DCHANNELPOT' ...            % (6)
           };
panel_defs = {'-DPANELSORT' ...           % (1)
              '-DPANELDUMMYFACTOR=2' ...  % (2)
              '-DPANELSHRINKBOX' ...      % (3)
              '-DPANELSHRINKBOXLIMIT=8096' ...  % (4)
              '-DGENERALPANELSUPPORT'     % (5)
             };
exp_defs = {'-DRADIALSHRINK' ...          % (1)
            '-DRADIALSHRINKLIMIT=512' ... % (2)
            '-DCUDATIMESORT' ...          % (3)
            '-DASYMMETRIC_CPU' ...        % (4)
            '-DUNROLLHORNER' ...          % (5)
            '-DUNROLLLEVEL=6' ...         % (6)
            '-DSSE2INTRINSIC' ...         % (7)
            '-DSSE2M2PSSCALING' ...       % (8)
            '-DSSE2DIRECT' ...            % (9)
            '-DSSEEVALUNROLL' ...         % (10)
            '-DSSE2INIT' ...              % (11)
            '-DCROSSORDER' ...            % (12)
            '-DFULLCROSSORDER' ...        % (13)
            '-DUNROLLHORNEROLD' ...       % (14)
            '-DM2PSINBOX' ...             % (15)
            '-DCHECKNANINPUT' ...         % (16)
            '-DOSEENSSEALTERNATIVE' ...   % (17)
            '-DNOITERACTIONWITHEMPTY'};   % (18)
cuda_defs = {'-DCUDATIME' ...             % (1)
             '-DCUDASUPPORT' ...          % (2)
             '-DMULTIPOLEEVALCUDA' ...    % (3)
             '-DMULTIPOLEINITCUDA' ...    % (4)
             '-DMULTIPOLESHIFTCUDA' ...   % (5)
             '-DCUDASORT' ...             % (6)
             '-DSORTLIMIT' ...            % (7)
             '-DSORTLIMITVALUES={1,0.5,-0.5,1,-1,0.5}' ... % (8)
            };
%for normal CPU simulation
CPU_args=[debug_defs([]) platform_defs([]) fmm_defs ...
              panel_defs exp_defs([1:2 5:7 8 9:11 13 15]) cuda_defs(1)];

make('gpu',CPU_args{:});